/*
Hide My Movie v1
By Hakuryu188
http://hakuryu188-dev.blogspot.com/
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspdisplay.h>

PSP_MODULE_INFO("PRX", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

void BASIC_Sleep(int secondes);
void printTextWithBg(int x, int y, const char* text, u32 color, u32 bgcolor);

unsigned char statut;
int folder;
unsigned char foldervideo;
unsigned char r;
unsigned char rold;
char *message;
int temps;
int x;

int main_thread(SceSize args, void *argp)
{
	pspDebugScreenInit();
	pspDebugScreenEnableBackColor(0);

	BASIC_Sleep(6);

	SceCtrlData pad;

	statut = 1;

	while(1)
	{

		sceCtrlPeekBufferPositive(&pad, 1);
		sceCtrlSetSamplingCycle(0);
		sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);


		if (pad.Buttons & PSP_CTRL_RTRIGGER){
			r = 1;
		}else {
			r = 0;
			rold = 1;
		}

		if (statut == 1){

			if (r == 1 && rold == 1 && pad.Ly > (127.5 + 60) && pad.Buttons & PSP_CTRL_CIRCLE){
				statut = 2;
				rold = 0;
			}

		}else if (statut == 2){

			sceCtrlReadBufferPositive (&pad, 1);

			folder = sceIoDopen("ms0:/HIDEVIDEO");
			if (folder >= 0){
				foldervideo = 1;
				message = "Unhiding...";
				x = 180;
			}else {
				folder = sceIoDopen("ms0:/VIDEO");
				if (folder >= 0){
					foldervideo = 2;
					message = "Hiding...";
					x = 180;
				}else {
					foldervideo = 3;
					message = "Sorry, Hakuryu188 haven't found your movies";\
					x = 80;
				}
			}

			temps = 0;
			statut = 3;

		}else if (statut == 3){

			sceCtrlReadBufferPositive (&pad, 1);

			if (temps < 140){
				printTextWithBg(x, 50, message, 0xFF0000FF, 0xFFFFFFFF);
				temps++;
			}else {
				statut = 4;
			}

		}else if (statut == 4){

			sceCtrlReadBufferPositive (&pad, 1);

			if (foldervideo == 1){
				sceIoRmdir("ms0:/VIDEO");
				sceIoRename("ms0:/HIDEVIDEO", "ms0:/VIDEO");
				statut = 1;
			}else if (foldervideo == 2){
				sceIoRename("ms0:/VIDEO", "ms0:/HIDEVIDEO");
				statut = 1;
			}else if (foldervideo == 3){
				statut = 1;
			}

		}

		 sceKernelDelayThread(50);

	}

   return 0;
}


int module_start(SceSize args, void *argp)
{
int thid = sceKernelCreateThread("PRX", main_thread, 0x30, 0x1000, 0, NULL);
if(thid >= 0) sceKernelStartThread(thid, args, argp);

return 0;
}

void BASIC_Sleep(int secondes)
{
	sceKernelDelayThread(1000000*secondes);
}

void printTextWithBg(int x, int y, const char* text, u32 color, u32 bgcolor) {
  u32 vram32 = 0;
  int offset;
  pspDebugScreenEnableBackColor(1);
  pspDebugScreenSetBackColor(bgcolor);
  pspDebugScreenSetTextColor(color);
  sceDisplayGetFrameBuf((void*)vram32, &offset, &offset, (int)offset); //using 'offset' as a dummy var
  offset = vram32 - 0x40000000;
  offset += ((x + (y << 9)) << 2);
  pspDebugScreenSetOffset(offset);
  pspDebugScreenSetXY(0, 0);
  pspDebugScreenKprintf(text);
}
